import * as Vue3 from 'vue';
import { InteractionInfo } from '@visoning/vue-floating-interactions';
import { Interaction } from './Popover.types';
import './styles/index.scss';
export declare const Popover: Vue3.DefineComponent<import("@visoning/vue-utility").WithDefaultProps<{
    readonly defaultOpen: BooleanConstructor;
    readonly interactions: Vue3.PropType<Interaction[]>;
    readonly delay: Vue3.PropType<number>;
    readonly clickDelay: Vue3.PropType<number>;
    readonly hoverDelay: Vue3.PropType<number>;
    readonly focusDelay: Vue3.PropType<number>;
    readonly keepOpenWhenPopupHover: BooleanConstructor;
    readonly closeWhenClickOutside: BooleanConstructor;
    readonly content: Vue3.PropType<string | (() => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly title: Vue3.PropType<string | (() => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly theme: Vue3.PropType<"dark" | "light">;
    readonly size: Vue3.PropType<"small" | "meduim">;
    readonly transitionProps: Vue3.PropType<string | Record<string, any>>;
    readonly showArrow: BooleanConstructor;
    readonly arrow: Vue3.PropType<import("./Popover.types").CreateArrow>;
    readonly arrowProps: Vue3.PropType<Record<string, any>>;
    readonly popoverProps: Vue3.PropType<Record<string, any>>;
    readonly contentProps: Vue3.PropType<Record<string, any>>;
    readonly popoverWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly 'onUpdate:open': Vue3.PropType<(open: boolean, info: InteractionInfo) => void>;
    readonly onOpen: Vue3.PropType<(info: InteractionInfo) => void>;
    readonly onClose: Vue3.PropType<(info: InteractionInfo) => void>;
    readonly onFloatingDataUpdate: Vue3.PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/dom").Strategy;
        placement: import("@floating-ui/dom").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/dom").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/dom").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: Vue3.PropType<import("@floating-ui/core").OffsetOptions>;
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly disabled: BooleanConstructor;
    readonly reference: {
        type: Vue3.PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: Vue3.PropType<HTMLElement>;
    };
    readonly strategy: Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/dom").Strategy & {};
    } | {
        type: () => import("@floating-ui/dom").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/dom").Strategy & {}) | (() => import("@floating-ui/dom").Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly autoPlacement: Vue3.PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: Vue3.PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: Vue3.PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/dom").Placement & {};
    } | {
        type: () => import("@floating-ui/dom").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/dom").Placement & {}) | (() => import("@floating-ui/dom").Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: Vue3.PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: Vue3.PropType<Record<string, any>>;
    readonly popupProps: Vue3.PropType<Record<string, any>>;
    readonly popupWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly open: any;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>, () => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, Vue3.ComponentOptionsMixin, Vue3.ComponentOptionsMixin, {}, string, Vue3.VNodeProps & Vue3.AllowedComponentProps & Vue3.ComponentCustomProps, Readonly<Vue3.ExtractPropTypes<import("@visoning/vue-utility").WithDefaultProps<{
    readonly defaultOpen: BooleanConstructor;
    readonly interactions: Vue3.PropType<Interaction[]>;
    readonly delay: Vue3.PropType<number>;
    readonly clickDelay: Vue3.PropType<number>;
    readonly hoverDelay: Vue3.PropType<number>;
    readonly focusDelay: Vue3.PropType<number>;
    readonly keepOpenWhenPopupHover: BooleanConstructor;
    readonly closeWhenClickOutside: BooleanConstructor;
    readonly content: Vue3.PropType<string | (() => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly title: Vue3.PropType<string | (() => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly theme: Vue3.PropType<"dark" | "light">;
    readonly size: Vue3.PropType<"small" | "meduim">;
    readonly transitionProps: Vue3.PropType<string | Record<string, any>>;
    readonly showArrow: BooleanConstructor;
    readonly arrow: Vue3.PropType<import("./Popover.types").CreateArrow>;
    readonly arrowProps: Vue3.PropType<Record<string, any>>;
    readonly popoverProps: Vue3.PropType<Record<string, any>>;
    readonly contentProps: Vue3.PropType<Record<string, any>>;
    readonly popoverWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly 'onUpdate:open': Vue3.PropType<(open: boolean, info: InteractionInfo) => void>;
    readonly onOpen: Vue3.PropType<(info: InteractionInfo) => void>;
    readonly onClose: Vue3.PropType<(info: InteractionInfo) => void>;
    readonly onFloatingDataUpdate: Vue3.PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/dom").Strategy;
        placement: import("@floating-ui/dom").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/dom").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/dom").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: Vue3.PropType<import("@floating-ui/core").OffsetOptions>;
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly disabled: BooleanConstructor;
    readonly reference: {
        type: Vue3.PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: Vue3.PropType<HTMLElement>;
    };
    readonly strategy: Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/dom").Strategy & {};
    } | {
        type: () => import("@floating-ui/dom").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/dom").Strategy & {}) | (() => import("@floating-ui/dom").Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly autoPlacement: Vue3.PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: Vue3.PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: Vue3.PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/dom").Placement & {};
    } | {
        type: () => import("@floating-ui/dom").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/dom").Placement & {}) | (() => import("@floating-ui/dom").Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: Vue3.PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: Vue3.PropType<Record<string, any>>;
    readonly popupProps: Vue3.PropType<Record<string, any>>;
    readonly popupWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly open: any;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>>>, {
    readonly shift: boolean | import("@floating-ui/core").ShiftOptions;
    readonly open: boolean;
    readonly disabled: boolean;
    readonly size: "small" | "meduim";
    readonly strategy: import("@floating-ui/dom").Strategy;
    readonly placement: import("@floating-ui/dom").Placement;
    readonly autoUpdate: true;
    readonly appendTo: string | false | HTMLElement;
    readonly autoUpdateOnClosed: boolean;
    readonly gpuAcceleration: boolean;
    readonly destoryedOnClosed: boolean;
    readonly defaultOpen: boolean;
    readonly interactions: Interaction[];
    readonly keepOpenWhenPopupHover: boolean;
    readonly closeWhenClickOutside: boolean;
    readonly theme: "dark" | "light";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: boolean;
}>;
