import type { ExtractPropTypes, PropType, VNode } from 'vue-demi';
import type { InteractionInfo } from '@visoning/vue-floating-interactions';
import type { PopupSlotProps, PopupExposed } from '../popup';
export interface PopoverExposed extends PopupExposed {
}
export declare type PopoverArrowSlotProps = PopupSlotProps;
export declare type CreateArrow = (props: PopoverArrowSlotProps) => VNode | null;
export declare type Interaction = 'click' | 'hover' | 'focus';
export declare const PopupListenerPropsForwarder: import("@visoning/vue-utility").UseListenerForwardReturn<import("@visoning/vue-utility").WithDefaultProps<{
    readonly open: BooleanConstructor;
    readonly disabled: BooleanConstructor;
    readonly virtualElement: PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: PropType<string | false | HTMLElement>;
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly shift: PropType<boolean | import("@floating-ui/core").ShiftOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Strategy & {};
    } | {
        type: () => import("@floating-ui/core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Strategy & {}) | (() => import("@floating-ui/core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Placement & {};
    } | {
        type: () => import("@floating-ui/core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Placement & {}) | (() => import("@floating-ui/core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
}, {
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>, "onFloatingDataUpdate">;
export declare const ExtendsPopupProps: Pick<import("@visoning/vue-utility").WithDefaultProps<{
    readonly open: BooleanConstructor;
    readonly disabled: BooleanConstructor;
    readonly virtualElement: PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: PropType<string | false | HTMLElement>;
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly shift: PropType<boolean | import("@floating-ui/core").ShiftOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Strategy & {};
    } | {
        type: () => import("@floating-ui/core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Strategy & {}) | (() => import("@floating-ui/core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Placement & {};
    } | {
        type: () => import("@floating-ui/core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Placement & {}) | (() => import("@floating-ui/core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
}, {
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>, "shift" | "offset" | "open" | "zIndex" | "disabled" | "reference" | "floating" | "strategy" | "autoPlacement" | "flip" | "middleware" | "placement" | "autoUpdate" | "onFloatingDataUpdate" | "virtualElement" | "appendTo" | "autoUpdateOnClosed" | "gpuAcceleration" | "destoryedOnClosed" | "referenceProps" | "popupProps" | "popupWrapper" | "floatingWrapper">;
export declare const PopoverPropsType: {
    /**
     * Default open when not manually set.
     */
    readonly defaultOpen: BooleanConstructor;
    /**
     * Which actions cause popup shown. enum of 'hover','click','focus'.
     */
    readonly interactions: PropType<Interaction[]>;
    /**
     * Common delay in ms, before popup is open/close.
     */
    readonly delay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on pointer click.
     */
    readonly clickDelay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on pointer enter/leave.
     */
    readonly hoverDelay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on focus/blur.
     */
    readonly focusDelay: PropType<number>;
    /**
     * Whether to keep the popup open on mouse hover
     */
    readonly keepOpenWhenPopupHover: BooleanConstructor;
    /**
     * Whether to close by clicking outside.
     * @default true
     */
    readonly closeWhenClickOutside: BooleanConstructor;
    /**
     * support: string | () => VNode | slot
     */
    readonly content: PropType<string | (() => VNode)>;
    /**
     * support: string | () => VNode | slot
     */
    readonly title: PropType<string | (() => VNode)>;
    /**
     * The theme of the popover.
     * @default 'light'
     */
    readonly theme: PropType<"dark" | "light">;
    /**
     * The size of the popover.
     * @default 'meduim'
     */
    readonly size: PropType<"small" | "meduim">;
    /**
     * @see https://cn.vuejs.org/guide/built-ins/transition.html
     */
    readonly transitionProps: PropType<string | Record<string, any>>;
    /**
     * Whether to show arrow if set.
     * @default true
     */
    readonly showArrow: BooleanConstructor;
    /**
     * For style uniformity, we will never enable the configuration of arrow middleware,
     * you can customize arrow to make arrow more as expected.
     *
     * support: CreateArrow | slot
     */
    readonly arrow: PropType<CreateArrow>;
    /**
     * HTML attributes of node.
     */
    readonly arrowProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover node.
     */
    readonly popoverProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover-content node.
     */
    readonly contentProps: PropType<Record<string, any>>;
    /**
     * Custom popover node wrapper.
     */
    readonly popoverWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    /**
     * Callback on open status changes.
     */
    readonly 'onUpdate:open': PropType<(open: boolean, info: InteractionInfo) => void>;
    /**
     * Callback on popup open.
     */
    readonly onOpen: PropType<(info: InteractionInfo) => void>;
    /**
     * Callback on popup close.
     */
    readonly onClose: PropType<(info: InteractionInfo) => void>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly disabled: BooleanConstructor;
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Strategy & {};
    } | {
        type: () => import("@floating-ui/core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Strategy & {}) | (() => import("@floating-ui/core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Placement & {};
    } | {
        type: () => import("@floating-ui/core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Placement & {}) | (() => import("@floating-ui/core").Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
};
export declare const PopoverTransitionName = "visoning-popover";
export declare const PopoverDefaultProps: {
    readonly open: any;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
};
export declare const PopoverProps: import("@visoning/vue-utility").WithDefaultProps<{
    /**
     * Default open when not manually set.
     */
    readonly defaultOpen: BooleanConstructor;
    /**
     * Which actions cause popup shown. enum of 'hover','click','focus'.
     */
    readonly interactions: PropType<Interaction[]>;
    /**
     * Common delay in ms, before popup is open/close.
     */
    readonly delay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on pointer click.
     */
    readonly clickDelay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on pointer enter/leave.
     */
    readonly hoverDelay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on focus/blur.
     */
    readonly focusDelay: PropType<number>;
    /**
     * Whether to keep the popup open on mouse hover
     */
    readonly keepOpenWhenPopupHover: BooleanConstructor;
    /**
     * Whether to close by clicking outside.
     * @default true
     */
    readonly closeWhenClickOutside: BooleanConstructor;
    /**
     * support: string | () => VNode | slot
     */
    readonly content: PropType<string | (() => VNode)>;
    /**
     * support: string | () => VNode | slot
     */
    readonly title: PropType<string | (() => VNode)>;
    /**
     * The theme of the popover.
     * @default 'light'
     */
    readonly theme: PropType<"dark" | "light">;
    /**
     * The size of the popover.
     * @default 'meduim'
     */
    readonly size: PropType<"small" | "meduim">;
    /**
     * @see https://cn.vuejs.org/guide/built-ins/transition.html
     */
    readonly transitionProps: PropType<string | Record<string, any>>;
    /**
     * Whether to show arrow if set.
     * @default true
     */
    readonly showArrow: BooleanConstructor;
    /**
     * For style uniformity, we will never enable the configuration of arrow middleware,
     * you can customize arrow to make arrow more as expected.
     *
     * support: CreateArrow | slot
     */
    readonly arrow: PropType<CreateArrow>;
    /**
     * HTML attributes of node.
     */
    readonly arrowProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover node.
     */
    readonly popoverProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover-content node.
     */
    readonly contentProps: PropType<Record<string, any>>;
    /**
     * Custom popover node wrapper.
     */
    readonly popoverWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    /**
     * Callback on open status changes.
     */
    readonly 'onUpdate:open': PropType<(open: boolean, info: InteractionInfo) => void>;
    /**
     * Callback on popup open.
     */
    readonly onOpen: PropType<(info: InteractionInfo) => void>;
    /**
     * Callback on popup close.
     */
    readonly onClose: PropType<(info: InteractionInfo) => void>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly disabled: BooleanConstructor;
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Strategy & {};
    } | {
        type: () => import("@floating-ui/core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Strategy & {}) | (() => import("@floating-ui/core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Placement & {};
    } | {
        type: () => import("@floating-ui/core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Placement & {}) | (() => import("@floating-ui/core").Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly open: any;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>;
export declare type PopoverProps = ExtractPropTypes<typeof PopoverProps>;
