import type { VNode } from 'vue-demi';
import * as Vue3 from 'vue';
import type { Middleware } from '@visoning/vue-floating-core';
export declare const Popup: Vue3.DefineComponent<import("@visoning/vue-utility").WithDefaultProps<{
    readonly open: BooleanConstructor;
    readonly disabled: BooleanConstructor;
    readonly virtualElement: Vue3.PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: Vue3.PropType<string | false | HTMLElement>;
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly offset: Vue3.PropType<import("@floating-ui/core").OffsetOptions>;
    readonly shift: Vue3.PropType<boolean | import("@floating-ui/core").ShiftOptions>;
    readonly flip: Vue3.PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly autoPlacement: Vue3.PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: Vue3.PropType<Record<string, any>>;
    readonly popupProps: Vue3.PropType<Record<string, any>>;
    readonly popupWrapper: Vue3.PropType<(popup: VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>) => VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: Vue3.PropType<(popup: VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>) => VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly onFloatingDataUpdate: Vue3.PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/dom").Strategy;
        placement: import("@floating-ui/dom").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/dom").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/dom").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly reference: {
        type: Vue3.PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: Vue3.PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@floating-ui/dom").Strategy & {};
    } | {
        type: () => import("@floating-ui/dom").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/dom").Strategy & {}) | (() => import("@floating-ui/dom").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: Vue3.PropType<Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@floating-ui/dom").Placement & {};
    } | {
        type: () => import("@floating-ui/dom").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/dom").Placement & {}) | (() => import("@floating-ui/dom").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
}, {
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>, () => VNode<Vue3.RendererNode, Vue3.RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, Vue3.ComponentOptionsMixin, Vue3.ComponentOptionsMixin, {}, string, Vue3.VNodeProps & Vue3.AllowedComponentProps & Vue3.ComponentCustomProps, Readonly<Vue3.ExtractPropTypes<import("@visoning/vue-utility").WithDefaultProps<{
    readonly open: BooleanConstructor;
    readonly disabled: BooleanConstructor;
    readonly virtualElement: Vue3.PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: Vue3.PropType<string | false | HTMLElement>;
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly offset: Vue3.PropType<import("@floating-ui/core").OffsetOptions>;
    readonly shift: Vue3.PropType<boolean | import("@floating-ui/core").ShiftOptions>;
    readonly flip: Vue3.PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly autoPlacement: Vue3.PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: Vue3.PropType<Record<string, any>>;
    readonly popupProps: Vue3.PropType<Record<string, any>>;
    readonly popupWrapper: Vue3.PropType<(popup: VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>) => VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: Vue3.PropType<(popup: VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>) => VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly onFloatingDataUpdate: Vue3.PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/dom").Strategy;
        placement: import("@floating-ui/dom").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/dom").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/dom").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly reference: {
        type: Vue3.PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: Vue3.PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@floating-ui/dom").Strategy & {};
    } | {
        type: () => import("@floating-ui/dom").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/dom").Strategy & {}) | (() => import("@floating-ui/dom").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: Vue3.PropType<Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@floating-ui/dom").Placement & {};
    } | {
        type: () => import("@floating-ui/dom").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/dom").Placement & {}) | (() => import("@floating-ui/dom").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
}, {
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>>>, {
    readonly shift: boolean | import("@floating-ui/core").ShiftOptions;
    readonly open: boolean;
    readonly disabled: boolean;
    readonly strategy: import("@floating-ui/dom").Strategy;
    readonly placement: import("@floating-ui/dom").Placement;
    readonly autoUpdate: true;
    readonly appendTo: string | false | HTMLElement;
    readonly autoUpdateOnClosed: boolean;
    readonly gpuAcceleration: boolean;
    readonly destoryedOnClosed: boolean;
}>;
