import type { ExtractPropTypes, PropType, VNode } from 'vue-demi';
import { PopoverExposed } from '../popover';
import type { PopoverArrowSlotProps } from '../popover';
export interface TooltipExposed extends PopoverExposed {
}
export declare type TooltipArrowSlotProps = PopoverArrowSlotProps;
export declare const PopoverListenerPropsForwarder: import("@visoning/vue-utility").UseListenerForwardReturn<import("@visoning/vue-utility").WithDefaultProps<{
    readonly defaultOpen: BooleanConstructor;
    readonly interactions: PropType<import("../popover").Interaction[]>;
    readonly delay: PropType<number>;
    readonly clickDelay: PropType<number>;
    readonly hoverDelay: PropType<number>;
    readonly focusDelay: PropType<number>;
    readonly keepOpenWhenPopupHover: BooleanConstructor;
    readonly closeWhenClickOutside: BooleanConstructor;
    readonly content: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly title: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly theme: PropType<"dark" | "light">;
    readonly size: PropType<"small" | "meduim">;
    readonly transitionProps: PropType<string | Record<string, any>>;
    readonly showArrow: BooleanConstructor;
    readonly arrow: PropType<import("../popover").CreateArrow>;
    readonly arrowProps: PropType<Record<string, any>>;
    readonly popoverProps: PropType<Record<string, any>>;
    readonly contentProps: PropType<Record<string, any>>;
    readonly popoverWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly 'onUpdate:open': PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").InteractionInfo) => void>;
    readonly onOpen: PropType<(info: import("@visoning/vue-floating-interactions").InteractionInfo) => void>;
    readonly onClose: PropType<(info: import("@visoning/vue-floating-interactions").InteractionInfo) => void>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly disabled: BooleanConstructor;
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Strategy & {};
    } | {
        type: () => import("@floating-ui/core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Strategy & {}) | (() => import("@floating-ui/core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Placement & {};
    } | {
        type: () => import("@floating-ui/core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Placement & {}) | (() => import("@floating-ui/core").Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly open: any;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>, "onFloatingDataUpdate" | "onUpdate:open" | "onOpen" | "onClose">;
export declare const ExtendsPopoverProps: Pick<import("@visoning/vue-utility").WithDefaultProps<{
    readonly defaultOpen: BooleanConstructor;
    readonly interactions: PropType<import("../popover").Interaction[]>;
    readonly delay: PropType<number>;
    readonly clickDelay: PropType<number>;
    readonly hoverDelay: PropType<number>;
    readonly focusDelay: PropType<number>;
    readonly keepOpenWhenPopupHover: BooleanConstructor;
    readonly closeWhenClickOutside: BooleanConstructor;
    readonly content: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly title: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly theme: PropType<"dark" | "light">;
    readonly size: PropType<"small" | "meduim">;
    readonly transitionProps: PropType<string | Record<string, any>>;
    readonly showArrow: BooleanConstructor;
    readonly arrow: PropType<import("../popover").CreateArrow>;
    readonly arrowProps: PropType<Record<string, any>>;
    readonly popoverProps: PropType<Record<string, any>>;
    readonly contentProps: PropType<Record<string, any>>;
    readonly popoverWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly 'onUpdate:open': PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").InteractionInfo) => void>;
    readonly onOpen: PropType<(info: import("@visoning/vue-floating-interactions").InteractionInfo) => void>;
    readonly onClose: PropType<(info: import("@visoning/vue-floating-interactions").InteractionInfo) => void>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly disabled: BooleanConstructor;
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Strategy & {};
    } | {
        type: () => import("@floating-ui/core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Strategy & {}) | (() => import("@floating-ui/core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Placement & {};
    } | {
        type: () => import("@floating-ui/core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Placement & {}) | (() => import("@floating-ui/core").Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly open: any;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>, "shift" | "offset" | "open" | "content" | "zIndex" | "title" | "disabled" | "size" | "reference" | "floating" | "strategy" | "arrow" | "autoPlacement" | "flip" | "middleware" | "placement" | "autoUpdate" | "onFloatingDataUpdate" | "virtualElement" | "appendTo" | "autoUpdateOnClosed" | "gpuAcceleration" | "destoryedOnClosed" | "referenceProps" | "popupProps" | "popupWrapper" | "floatingWrapper" | "defaultOpen" | "interactions" | "delay" | "clickDelay" | "hoverDelay" | "focusDelay" | "keepOpenWhenPopupHover" | "closeWhenClickOutside" | "theme" | "transitionProps" | "showArrow" | "arrowProps" | "popoverProps" | "contentProps" | "popoverWrapper" | "onUpdate:open" | "onOpen" | "onClose">;
export declare const TooltipPropsType: {
    /**
     * support: string | VNode | slot
     */
    readonly content: PropType<string | (() => VNode)>;
    /**
     * align tooltip content. enum of CSS text-align.
     * @default 'start'
     */
    readonly textAlign: PropType<"center" | "end" | "start" | "left" | "right" | "justify" | "match-parent">;
    /**
     * HTML attributes of node.
     */
    readonly tooltipProps: PropType<Record<string, any>>;
    /**
     * Custom tooltip node wrapper.
     */
    readonly tooltipWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly 'onUpdate:open': PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").InteractionInfo) => void>;
    readonly onOpen: PropType<(info: import("@visoning/vue-floating-interactions").InteractionInfo) => void>;
    readonly onClose: PropType<(info: import("@visoning/vue-floating-interactions").InteractionInfo) => void>;
    readonly shift: Omit<Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly title: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly disabled: BooleanConstructor;
    readonly size: Omit<{
        type: new (...args: any[]) => ("small" | "meduim") & {};
    } | {
        type: () => "small" | "meduim";
    } | {
        type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
    }, "default"> & {
        default: "meduim";
    };
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Strategy & {};
    } | {
        type: () => import("@floating-ui/core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Strategy & {}) | (() => import("@floating-ui/core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly arrow: PropType<import("../popover").CreateArrow>;
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Placement & {};
    } | {
        type: () => import("@floating-ui/core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Placement & {}) | (() => import("@floating-ui/core").Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<Omit<Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: Omit<Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly defaultOpen: BooleanConstructor;
    readonly interactions: Omit<{
        type: new (...args: any[]) => import("../popover").Interaction[];
    } | {
        type: () => import("../popover").Interaction[];
    } | {
        type: ((new (...args: any[]) => import("../popover").Interaction[]) | (() => import("../popover").Interaction[]))[];
    }, "default"> & {
        default: () => string[];
    };
    readonly delay: PropType<number>;
    readonly clickDelay: PropType<number>;
    readonly hoverDelay: PropType<number>;
    readonly focusDelay: PropType<number>;
    readonly keepOpenWhenPopupHover: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly closeWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly theme: Omit<{
        type: new (...args: any[]) => ("dark" | "light") & {};
    } | {
        type: () => "dark" | "light";
    } | {
        type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
    }, "default"> & {
        default: "line";
    };
    readonly transitionProps: Omit<{
        type: new (...args: any[]) => (string | Record<string, any>) & {};
    } | {
        type: () => string | Record<string, any>;
    } | {
        type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
    }, "default"> & {
        default: "visoning-popover";
    };
    readonly showArrow: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly arrowProps: PropType<Record<string, any>>;
    readonly popoverProps: PropType<Record<string, any>>;
    readonly contentProps: PropType<Record<string, any>>;
    readonly popoverWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
};
export declare const TooltipDefaultProps: {
    readonly textAlign: "start";
    readonly open: any;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
};
export declare const TooltipProps: import("@visoning/vue-utility").WithDefaultProps<{
    /**
     * support: string | VNode | slot
     */
    readonly content: PropType<string | (() => VNode)>;
    /**
     * align tooltip content. enum of CSS text-align.
     * @default 'start'
     */
    readonly textAlign: PropType<"center" | "end" | "start" | "left" | "right" | "justify" | "match-parent">;
    /**
     * HTML attributes of node.
     */
    readonly tooltipProps: PropType<Record<string, any>>;
    /**
     * Custom tooltip node wrapper.
     */
    readonly tooltipWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly 'onUpdate:open': PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").InteractionInfo) => void>;
    readonly onOpen: PropType<(info: import("@visoning/vue-floating-interactions").InteractionInfo) => void>;
    readonly onClose: PropType<(info: import("@visoning/vue-floating-interactions").InteractionInfo) => void>;
    readonly shift: Omit<Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly title: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly disabled: BooleanConstructor;
    readonly size: Omit<{
        type: new (...args: any[]) => ("small" | "meduim") & {};
    } | {
        type: () => "small" | "meduim";
    } | {
        type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
    }, "default"> & {
        default: "meduim";
    };
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Strategy & {};
    } | {
        type: () => import("@floating-ui/core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Strategy & {}) | (() => import("@floating-ui/core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly arrow: PropType<import("../popover").CreateArrow>;
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<Omit<Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Placement & {};
    } | {
        type: () => import("@floating-ui/core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Placement & {}) | (() => import("@floating-ui/core").Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<Omit<Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: Omit<Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly defaultOpen: BooleanConstructor;
    readonly interactions: Omit<{
        type: new (...args: any[]) => import("../popover").Interaction[];
    } | {
        type: () => import("../popover").Interaction[];
    } | {
        type: ((new (...args: any[]) => import("../popover").Interaction[]) | (() => import("../popover").Interaction[]))[];
    }, "default"> & {
        default: () => string[];
    };
    readonly delay: PropType<number>;
    readonly clickDelay: PropType<number>;
    readonly hoverDelay: PropType<number>;
    readonly focusDelay: PropType<number>;
    readonly keepOpenWhenPopupHover: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly closeWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly theme: Omit<{
        type: new (...args: any[]) => ("dark" | "light") & {};
    } | {
        type: () => "dark" | "light";
    } | {
        type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
    }, "default"> & {
        default: "line";
    };
    readonly transitionProps: Omit<{
        type: new (...args: any[]) => (string | Record<string, any>) & {};
    } | {
        type: () => string | Record<string, any>;
    } | {
        type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
    }, "default"> & {
        default: "visoning-popover";
    };
    readonly showArrow: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly arrowProps: PropType<Record<string, any>>;
    readonly popoverProps: PropType<Record<string, any>>;
    readonly contentProps: PropType<Record<string, any>>;
    readonly popoverWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly textAlign: "start";
    readonly open: any;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>;
export declare type TooltipProps = ExtractPropTypes<typeof TooltipProps>;
