import { AllowedComponentProps } from 'vue-demi';
import { AutoPlacementOptions } from '@floating-ui/core';
import { AutoUpdateOptions as AutoUpdateOptions_2 } from '@floating-ui/dom';
import { ComponentCustomProps } from 'vue-demi';
import { ComponentOptionsMixin } from 'vue-demi';
import { DefineComponent } from 'vue-demi';
import { ExtractPropTypes } from 'vue-demi';
import { FlipOptions } from '@floating-ui/core';
import { Middleware } from '@floating-ui/core';
import type { MiddlewareData } from '@floating-ui/core';
import { OffsetOptions } from '@floating-ui/core';
import { Placement } from '@floating-ui/core';
import { Placement as Placement_2 } from '@floating-ui/dom';
import { PropType } from 'vue-demi';
import type { Ref } from 'vue-demi';
import { RendererElement } from 'vue-demi';
import { RendererNode } from 'vue-demi';
import { ShiftOptions } from '@floating-ui/core';
import { Strategy } from '@floating-ui/core';
import { Strategy as Strategy_2 } from '@floating-ui/dom';
import { VirtualElement } from '@floating-ui/dom';
import { VNode } from 'vue-demi';
import { VNodeProps } from 'vue-demi';
import * as Vue3 from 'vue';
import { WithDefaultProps } from '@visoning/vue-utility';

export declare type AutoUpdateOptions = UseAutoUpdateOptions

export declare type CreateArrow = (props: PopoverArrowSlotProps) => VNode | null;

export declare const createReferenceForwardContext: (referenceRef?: Ref<ForwardReferenceType>) => Ref<ReferenceType>;

export declare type FloatingData = UseFloatingData

declare type FloatingType = HTMLElement

export declare interface ForwardReferenceContextValue {
    forwardReference: (reference: ForwardReferenceType) => void;
}

export declare type ForwardReferenceType = ReferenceType | undefined;

export declare type Interaction = 'click' | 'hover' | 'focus';

/**
 * The info of action that finally sets open.
 */
declare interface InteractionInfo {
    type: string
    event?: Event | null
}

export { Middleware }

export { MiddlewareData }

export { Placement }

export declare const Popover: Vue3.DefineComponent<WithDefaultProps<    {
readonly defaultOpen: BooleanConstructor;
readonly interactions: Vue3.PropType<Interaction[]>;
readonly delay: Vue3.PropType<number>;
readonly clickDelay: Vue3.PropType<number>;
readonly hoverDelay: Vue3.PropType<number>;
readonly focusDelay: Vue3.PropType<number>;
readonly keepOpenWhenPopupHover: BooleanConstructor;
readonly closeWhenClickOutside: BooleanConstructor;
readonly content: Vue3.PropType<string | (() => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>)>;
readonly title: Vue3.PropType<string | (() => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>)>;
readonly theme: Vue3.PropType<"dark" | "light">;
readonly size: Vue3.PropType<"small" | "meduim">;
readonly transitionProps: Vue3.PropType<string | Record<string, any>>;
readonly showArrow: BooleanConstructor;
readonly arrow: Vue3.PropType<CreateArrow>;
readonly arrowProps: Vue3.PropType<Record<string, any>>;
readonly popoverProps: Vue3.PropType<Record<string, any>>;
readonly contentProps: Vue3.PropType<Record<string, any>>;
readonly popoverWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>>;
readonly 'onUpdate:open': Vue3.PropType<(open: boolean, info: InteractionInfo) => void>;
readonly onOpen: Vue3.PropType<(info: InteractionInfo) => void>;
readonly onClose: Vue3.PropType<(info: InteractionInfo) => void>;
readonly onFloatingDataUpdate: Vue3.PropType<(data: {
x: number;
y: number;
strategy: Strategy_2;
placement: Placement_2;
middlewareData: {
[x: string]: any;
arrow?: {
x?: number;
y?: number;
centerOffset: number;
};
autoPlacement?: {
index?: number;
overflows: {
placement: Placement_2;
overflows: number[];
}[];
};
flip?: {
index?: number;
overflows: {
placement: Placement_2;
overflows: number[];
}[];
};
hide?: {
referenceHidden?: boolean;
escaped?: boolean;
referenceHiddenOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
escapedOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
};
offset?: {
x: number;
y: number;
};
shift?: {
x: number;
y: number;
};
};
}) => void>;
readonly shift: Omit<{
type: new (...args: any[]) => (boolean | ShiftOptions) & {};
} | {
type: () => boolean | ShiftOptions;
} | {
type: ((new (...args: any[]) => (boolean | ShiftOptions) & {}) | (() => boolean | ShiftOptions))[];
}, "default"> & {
default: true;
};
readonly offset: Vue3.PropType<OffsetOptions>;
readonly open: BooleanConstructor;
readonly zIndex: NumberConstructor;
readonly disabled: BooleanConstructor;
readonly reference: {
type: Vue3.PropType<ReferenceType>;
};
readonly floating: {
type: Vue3.PropType<HTMLElement>;
};
readonly strategy: Omit<Omit<{
type: new (...args: any[]) => Strategy_2 & {};
} | {
type: () => Strategy_2;
} | {
type: ((new (...args: any[]) => Strategy_2 & {}) | (() => Strategy_2))[];
}, "default"> & {
default: "absolute";
}, "default"> & {
default: "absolute";
};
readonly autoPlacement: Vue3.PropType<boolean | AutoPlacementOptions>;
readonly flip: Vue3.PropType<boolean | FlipOptions>;
readonly middleware: Vue3.PropType<Middleware[]>;
readonly placement: Omit<Omit<{
type: new (...args: any[]) => Placement_2 & {};
} | {
type: () => Placement_2;
} | {
type: ((new (...args: any[]) => Placement_2 & {}) | (() => Placement_2))[];
}, "default"> & {
default: "bottom";
}, "default"> & {
default: "bottom";
};
readonly autoUpdate: Omit<Omit<{
type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
} | {
type: () => boolean | UseAutoUpdateOptions;
} | {
type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
}, "default"> & {
default: true;
}, "default"> & {
default: true;
};
readonly virtualElement: Vue3.PropType<VirtualElement>;
readonly appendTo: Omit<{
type: new (...args: any[]) => (string | false | HTMLElement) & {};
} | {
type: () => string | false | HTMLElement;
} | {
type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
}, "default"> & {
default: "body";
};
readonly autoUpdateOnClosed: BooleanConstructor;
readonly gpuAcceleration: BooleanConstructor;
readonly destoryedOnClosed: BooleanConstructor;
readonly referenceProps: Vue3.PropType<Record<string, any>>;
readonly popupProps: Vue3.PropType<Record<string, any>>;
readonly popupWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>>;
readonly floatingWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>>;
}, {
readonly open: any;
readonly interactions: () => string[];
readonly keepOpenWhenPopupHover: true;
readonly closeWhenClickOutside: true;
readonly theme: "line";
readonly size: "meduim";
readonly transitionProps: "visoning-popover";
readonly showArrow: true;
readonly appendTo: "body";
readonly shift: true;
readonly placement: "bottom";
readonly strategy: "absolute";
readonly autoUpdate: true;
}>, () => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, Vue3.ComponentOptionsMixin, Vue3.ComponentOptionsMixin, {}, string, Vue3.VNodeProps & Vue3.AllowedComponentProps & Vue3.ComponentCustomProps, Readonly<Vue3.ExtractPropTypes<WithDefaultProps<    {
readonly defaultOpen: BooleanConstructor;
readonly interactions: Vue3.PropType<Interaction[]>;
readonly delay: Vue3.PropType<number>;
readonly clickDelay: Vue3.PropType<number>;
readonly hoverDelay: Vue3.PropType<number>;
readonly focusDelay: Vue3.PropType<number>;
readonly keepOpenWhenPopupHover: BooleanConstructor;
readonly closeWhenClickOutside: BooleanConstructor;
readonly content: Vue3.PropType<string | (() => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>)>;
readonly title: Vue3.PropType<string | (() => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>)>;
readonly theme: Vue3.PropType<"dark" | "light">;
readonly size: Vue3.PropType<"small" | "meduim">;
readonly transitionProps: Vue3.PropType<string | Record<string, any>>;
readonly showArrow: BooleanConstructor;
readonly arrow: Vue3.PropType<CreateArrow>;
readonly arrowProps: Vue3.PropType<Record<string, any>>;
readonly popoverProps: Vue3.PropType<Record<string, any>>;
readonly contentProps: Vue3.PropType<Record<string, any>>;
readonly popoverWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>>;
readonly 'onUpdate:open': Vue3.PropType<(open: boolean, info: InteractionInfo) => void>;
readonly onOpen: Vue3.PropType<(info: InteractionInfo) => void>;
readonly onClose: Vue3.PropType<(info: InteractionInfo) => void>;
readonly onFloatingDataUpdate: Vue3.PropType<(data: {
x: number;
y: number;
strategy: Strategy_2;
placement: Placement_2;
middlewareData: {
[x: string]: any;
arrow?: {
x?: number;
y?: number;
centerOffset: number;
};
autoPlacement?: {
index?: number;
overflows: {
placement: Placement_2;
overflows: number[];
}[];
};
flip?: {
index?: number;
overflows: {
placement: Placement_2;
overflows: number[];
}[];
};
hide?: {
referenceHidden?: boolean;
escaped?: boolean;
referenceHiddenOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
escapedOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
};
offset?: {
x: number;
y: number;
};
shift?: {
x: number;
y: number;
};
};
}) => void>;
readonly shift: Omit<{
type: new (...args: any[]) => (boolean | ShiftOptions) & {};
} | {
type: () => boolean | ShiftOptions;
} | {
type: ((new (...args: any[]) => (boolean | ShiftOptions) & {}) | (() => boolean | ShiftOptions))[];
}, "default"> & {
default: true;
};
readonly offset: Vue3.PropType<OffsetOptions>;
readonly open: BooleanConstructor;
readonly zIndex: NumberConstructor;
readonly disabled: BooleanConstructor;
readonly reference: {
type: Vue3.PropType<ReferenceType>;
};
readonly floating: {
type: Vue3.PropType<HTMLElement>;
};
readonly strategy: Omit<Omit<{
type: new (...args: any[]) => Strategy_2 & {};
} | {
type: () => Strategy_2;
} | {
type: ((new (...args: any[]) => Strategy_2 & {}) | (() => Strategy_2))[];
}, "default"> & {
default: "absolute";
}, "default"> & {
default: "absolute";
};
readonly autoPlacement: Vue3.PropType<boolean | AutoPlacementOptions>;
readonly flip: Vue3.PropType<boolean | FlipOptions>;
readonly middleware: Vue3.PropType<Middleware[]>;
readonly placement: Omit<Omit<{
type: new (...args: any[]) => Placement_2 & {};
} | {
type: () => Placement_2;
} | {
type: ((new (...args: any[]) => Placement_2 & {}) | (() => Placement_2))[];
}, "default"> & {
default: "bottom";
}, "default"> & {
default: "bottom";
};
readonly autoUpdate: Omit<Omit<{
type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
} | {
type: () => boolean | UseAutoUpdateOptions;
} | {
type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
}, "default"> & {
default: true;
}, "default"> & {
default: true;
};
readonly virtualElement: Vue3.PropType<VirtualElement>;
readonly appendTo: Omit<{
type: new (...args: any[]) => (string | false | HTMLElement) & {};
} | {
type: () => string | false | HTMLElement;
} | {
type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
}, "default"> & {
default: "body";
};
readonly autoUpdateOnClosed: BooleanConstructor;
readonly gpuAcceleration: BooleanConstructor;
readonly destoryedOnClosed: BooleanConstructor;
readonly referenceProps: Vue3.PropType<Record<string, any>>;
readonly popupProps: Vue3.PropType<Record<string, any>>;
readonly popupWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>>;
readonly floatingWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>>;
}, {
readonly open: any;
readonly interactions: () => string[];
readonly keepOpenWhenPopupHover: true;
readonly closeWhenClickOutside: true;
readonly theme: "line";
readonly size: "meduim";
readonly transitionProps: "visoning-popover";
readonly showArrow: true;
readonly appendTo: "body";
readonly shift: true;
readonly placement: "bottom";
readonly strategy: "absolute";
readonly autoUpdate: true;
}>>>, {
    readonly shift: boolean | ShiftOptions;
    readonly open: boolean;
    readonly disabled: boolean;
    readonly size: "small" | "meduim";
    readonly strategy: Strategy_2;
    readonly placement: Placement_2;
    readonly autoUpdate: true;
    readonly appendTo: string | false | HTMLElement;
    readonly autoUpdateOnClosed: boolean;
    readonly gpuAcceleration: boolean;
    readonly destoryedOnClosed: boolean;
    readonly defaultOpen: boolean;
    readonly interactions: Interaction[];
    readonly keepOpenWhenPopupHover: boolean;
    readonly closeWhenClickOutside: boolean;
    readonly theme: "dark" | "light";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: boolean;
}>;

export declare type PopoverArrowSlotProps = PopupSlotProps;

export declare const PopoverDefaultProps: {
    readonly open: any;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
};

export declare interface PopoverExposed extends PopupExposed {
}

export declare const PopoverProps: WithDefaultProps<    {
/**
* Default open when not manually set.
*/
readonly defaultOpen: BooleanConstructor;
/**
* Which actions cause popup shown. enum of 'hover','click','focus'.
*/
readonly interactions: PropType<Interaction[]>;
/**
* Common delay in ms, before popup is open/close.
*/
readonly delay: PropType<number>;
/**
* Delay in ms, before popup is open/close on pointer click.
*/
readonly clickDelay: PropType<number>;
/**
* Delay in ms, before popup is open/close on pointer enter/leave.
*/
readonly hoverDelay: PropType<number>;
/**
* Delay in ms, before popup is open/close on focus/blur.
*/
readonly focusDelay: PropType<number>;
/**
* Whether to keep the popup open on mouse hover
*/
readonly keepOpenWhenPopupHover: BooleanConstructor;
/**
* Whether to close by clicking outside.
* @default true
*/
readonly closeWhenClickOutside: BooleanConstructor;
/**
* support: string | () => VNode | slot
*/
readonly content: PropType<string | (() => VNode)>;
/**
* support: string | () => VNode | slot
*/
readonly title: PropType<string | (() => VNode)>;
/**
* The theme of the popover.
* @default 'light'
*/
readonly theme: PropType<"dark" | "light">;
/**
* The size of the popover.
* @default 'meduim'
*/
readonly size: PropType<"small" | "meduim">;
/**
* @see https://cn.vuejs.org/guide/built-ins/transition.html
*/
readonly transitionProps: PropType<string | Record<string, any>>;
/**
* Whether to show arrow if set.
* @default true
*/
readonly showArrow: BooleanConstructor;
/**
* For style uniformity, we will never enable the configuration of arrow middleware,
* you can customize arrow to make arrow more as expected.
*
* support: CreateArrow | slot
*/
readonly arrow: PropType<CreateArrow>;
/**
* HTML attributes of node.
*/
readonly arrowProps: PropType<Record<string, any>>;
/**
* HTML attributes of popover node.
*/
readonly popoverProps: PropType<Record<string, any>>;
/**
* HTML attributes of popover-content node.
*/
readonly contentProps: PropType<Record<string, any>>;
/**
* Custom popover node wrapper.
*/
readonly popoverWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
/**
* Callback on open status changes.
*/
readonly 'onUpdate:open': PropType<(open: boolean, info: InteractionInfo) => void>;
/**
* Callback on popup open.
*/
readonly onOpen: PropType<(info: InteractionInfo) => void>;
/**
* Callback on popup close.
*/
readonly onClose: PropType<(info: InteractionInfo) => void>;
readonly onFloatingDataUpdate: PropType<(data: {
x: number;
y: number;
strategy: Strategy;
placement: Placement;
middlewareData: {
[x: string]: any;
arrow?: {
x?: number;
y?: number;
centerOffset: number;
};
autoPlacement?: {
index?: number;
overflows: {
placement: Placement;
overflows: number[];
}[];
};
flip?: {
index?: number;
overflows: {
placement: Placement;
overflows: number[];
}[];
};
hide?: {
referenceHidden?: boolean;
escaped?: boolean;
referenceHiddenOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
escapedOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
};
offset?: {
x: number;
y: number;
};
shift?: {
x: number;
y: number;
};
};
}) => void>;
readonly shift: Omit<{
type: new (...args: any[]) => (boolean | ShiftOptions) & {};
} | {
type: () => boolean | ShiftOptions;
} | {
type: ((new (...args: any[]) => (boolean | ShiftOptions) & {}) | (() => boolean | ShiftOptions))[];
}, "default"> & {
default: true;
};
readonly offset: PropType<OffsetOptions>;
readonly open: BooleanConstructor;
readonly zIndex: NumberConstructor;
readonly disabled: BooleanConstructor;
readonly reference: {
type: PropType<ReferenceType>;
};
readonly floating: {
type: PropType<HTMLElement>;
};
readonly strategy: Omit<Omit<{
type: new (...args: any[]) => Strategy & {};
} | {
type: () => Strategy;
} | {
type: ((new (...args: any[]) => Strategy & {}) | (() => Strategy))[];
}, "default"> & {
default: "absolute";
}, "default"> & {
default: "absolute";
};
readonly autoPlacement: PropType<boolean | AutoPlacementOptions>;
readonly flip: PropType<boolean | FlipOptions>;
readonly middleware: PropType<Middleware[]>;
readonly placement: Omit<Omit<{
type: new (...args: any[]) => Placement & {};
} | {
type: () => Placement;
} | {
type: ((new (...args: any[]) => Placement & {}) | (() => Placement))[];
}, "default"> & {
default: "bottom";
}, "default"> & {
default: "bottom";
};
readonly autoUpdate: Omit<Omit<{
type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
} | {
type: () => boolean | UseAutoUpdateOptions;
} | {
type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
}, "default"> & {
default: true;
}, "default"> & {
default: true;
};
readonly virtualElement: PropType<VirtualElement>;
readonly appendTo: Omit<{
type: new (...args: any[]) => (string | false | HTMLElement) & {};
} | {
type: () => string | false | HTMLElement;
} | {
type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
}, "default"> & {
default: "body";
};
readonly autoUpdateOnClosed: BooleanConstructor;
readonly gpuAcceleration: BooleanConstructor;
readonly destoryedOnClosed: BooleanConstructor;
readonly referenceProps: PropType<Record<string, any>>;
readonly popupProps: PropType<Record<string, any>>;
readonly popupWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
readonly floatingWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
}, {
readonly open: any;
readonly interactions: () => string[];
readonly keepOpenWhenPopupHover: true;
readonly closeWhenClickOutside: true;
readonly theme: "line";
readonly size: "meduim";
readonly transitionProps: "visoning-popover";
readonly showArrow: true;
readonly appendTo: "body";
readonly shift: true;
readonly placement: "bottom";
readonly strategy: "absolute";
readonly autoUpdate: true;
}>;

export declare type PopoverProps = ExtractPropTypes<typeof PopoverProps>;

export declare const PopoverPropsType: {
    /**
     * Default open when not manually set.
     */
    readonly defaultOpen: BooleanConstructor;
    /**
     * Which actions cause popup shown. enum of 'hover','click','focus'.
     */
    readonly interactions: PropType<Interaction[]>;
    /**
     * Common delay in ms, before popup is open/close.
     */
    readonly delay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on pointer click.
     */
    readonly clickDelay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on pointer enter/leave.
     */
    readonly hoverDelay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on focus/blur.
     */
    readonly focusDelay: PropType<number>;
    /**
     * Whether to keep the popup open on mouse hover
     */
    readonly keepOpenWhenPopupHover: BooleanConstructor;
    /**
     * Whether to close by clicking outside.
     * @default true
     */
    readonly closeWhenClickOutside: BooleanConstructor;
    /**
     * support: string | () => VNode | slot
     */
    readonly content: PropType<string | (() => VNode)>;
    /**
     * support: string | () => VNode | slot
     */
    readonly title: PropType<string | (() => VNode)>;
    /**
     * The theme of the popover.
     * @default 'light'
     */
    readonly theme: PropType<"dark" | "light">;
    /**
     * The size of the popover.
     * @default 'meduim'
     */
    readonly size: PropType<"small" | "meduim">;
    /**
     * @see https://cn.vuejs.org/guide/built-ins/transition.html
     */
    readonly transitionProps: PropType<string | Record<string, any>>;
    /**
     * Whether to show arrow if set.
     * @default true
     */
    readonly showArrow: BooleanConstructor;
    /**
     * For style uniformity, we will never enable the configuration of arrow middleware,
     * you can customize arrow to make arrow more as expected.
     *
     * support: CreateArrow | slot
     */
    readonly arrow: PropType<CreateArrow>;
    /**
     * HTML attributes of node.
     */
    readonly arrowProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover node.
     */
    readonly popoverProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover-content node.
     */
    readonly contentProps: PropType<Record<string, any>>;
    /**
     * Custom popover node wrapper.
     */
    readonly popoverWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>) => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>>;
    /**
     * Callback on open status changes.
     */
    readonly 'onUpdate:open': PropType<(open: boolean, info: InteractionInfo) => void>;
    /**
     * Callback on popup open.
     */
    readonly onOpen: PropType<(info: InteractionInfo) => void>;
    /**
     * Callback on popup close.
     */
    readonly onClose: PropType<(info: InteractionInfo) => void>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: Strategy;
        placement: Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | ShiftOptions) & {};
    } | {
        type: () => boolean | ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | ShiftOptions) & {}) | (() => boolean | ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<OffsetOptions>;
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly disabled: BooleanConstructor;
    readonly reference: {
        type: PropType<ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<Omit<{
        type: new (...args: any[]) => Strategy & {};
    } | {
        type: () => Strategy;
    } | {
        type: ((new (...args: any[]) => Strategy & {}) | (() => Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly autoPlacement: PropType<boolean | AutoPlacementOptions>;
    readonly flip: PropType<boolean | FlipOptions>;
    readonly middleware: PropType<Middleware[]>;
    readonly placement: Omit<Omit<{
        type: new (...args: any[]) => Placement & {};
    } | {
        type: () => Placement;
    } | {
        type: ((new (...args: any[]) => Placement & {}) | (() => Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<Omit<{
        type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: PropType<VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>) => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>) => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>>;
};

export declare const PopoverTransitionName = "visoning-popover";

export declare const Popup: Vue3.DefineComponent<WithDefaultProps<    {
readonly open: BooleanConstructor;
readonly disabled: BooleanConstructor;
readonly virtualElement: Vue3.PropType<VirtualElement>;
readonly appendTo: Vue3.PropType<string | false | HTMLElement>;
readonly autoUpdateOnClosed: BooleanConstructor;
readonly offset: Vue3.PropType<OffsetOptions>;
readonly shift: Vue3.PropType<boolean | ShiftOptions>;
readonly flip: Vue3.PropType<boolean | FlipOptions>;
readonly autoPlacement: Vue3.PropType<boolean | AutoPlacementOptions>;
readonly gpuAcceleration: BooleanConstructor;
readonly destoryedOnClosed: BooleanConstructor;
readonly referenceProps: Vue3.PropType<Record<string, any>>;
readonly popupProps: Vue3.PropType<Record<string, any>>;
readonly popupWrapper: Vue3.PropType<(popup: VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>) => VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>>;
readonly floatingWrapper: Vue3.PropType<(popup: VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>) => VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>>;
readonly zIndex: NumberConstructor;
readonly onFloatingDataUpdate: Vue3.PropType<(data: {
x: number;
y: number;
strategy: Strategy_2;
placement: Placement_2;
middlewareData: {
[x: string]: any;
arrow?: {
x?: number;
y?: number;
centerOffset: number;
};
autoPlacement?: {
index?: number;
overflows: {
placement: Placement_2;
overflows: number[];
}[];
};
flip?: {
index?: number;
overflows: {
placement: Placement_2;
overflows: number[];
}[];
};
hide?: {
referenceHidden?: boolean;
escaped?: boolean;
referenceHiddenOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
escapedOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
};
offset?: {
x: number;
y: number;
};
shift?: {
x: number;
y: number;
};
};
}) => void>;
readonly reference: {
type: Vue3.PropType<ReferenceType>;
};
readonly floating: {
type: Vue3.PropType<HTMLElement>;
};
readonly strategy: Omit<{
type: new (...args: any[]) => Strategy_2 & {};
} | {
type: () => Strategy_2;
} | {
type: ((new (...args: any[]) => Strategy_2 & {}) | (() => Strategy_2))[];
}, "default"> & {
default: "absolute";
};
readonly middleware: Vue3.PropType<Middleware[]>;
readonly placement: Omit<{
type: new (...args: any[]) => Placement_2 & {};
} | {
type: () => Placement_2;
} | {
type: ((new (...args: any[]) => Placement_2 & {}) | (() => Placement_2))[];
}, "default"> & {
default: "bottom";
};
readonly autoUpdate: Omit<{
type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
} | {
type: () => boolean | UseAutoUpdateOptions;
} | {
type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
}, "default"> & {
default: true;
};
}, {
readonly appendTo: "body";
readonly shift: true;
readonly placement: "bottom";
readonly strategy: "absolute";
readonly autoUpdate: true;
}>, () => VNode<Vue3.RendererNode, Vue3.RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, Vue3.ComponentOptionsMixin, Vue3.ComponentOptionsMixin, {}, string, Vue3.VNodeProps & Vue3.AllowedComponentProps & Vue3.ComponentCustomProps, Readonly<Vue3.ExtractPropTypes<WithDefaultProps<    {
readonly open: BooleanConstructor;
readonly disabled: BooleanConstructor;
readonly virtualElement: Vue3.PropType<VirtualElement>;
readonly appendTo: Vue3.PropType<string | false | HTMLElement>;
readonly autoUpdateOnClosed: BooleanConstructor;
readonly offset: Vue3.PropType<OffsetOptions>;
readonly shift: Vue3.PropType<boolean | ShiftOptions>;
readonly flip: Vue3.PropType<boolean | FlipOptions>;
readonly autoPlacement: Vue3.PropType<boolean | AutoPlacementOptions>;
readonly gpuAcceleration: BooleanConstructor;
readonly destoryedOnClosed: BooleanConstructor;
readonly referenceProps: Vue3.PropType<Record<string, any>>;
readonly popupProps: Vue3.PropType<Record<string, any>>;
readonly popupWrapper: Vue3.PropType<(popup: VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>) => VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>>;
readonly floatingWrapper: Vue3.PropType<(popup: VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>) => VNode<Vue3.RendererNode, Vue3.RendererElement, {
[key: string]: any;
}>>;
readonly zIndex: NumberConstructor;
readonly onFloatingDataUpdate: Vue3.PropType<(data: {
x: number;
y: number;
strategy: Strategy_2;
placement: Placement_2;
middlewareData: {
[x: string]: any;
arrow?: {
x?: number;
y?: number;
centerOffset: number;
};
autoPlacement?: {
index?: number;
overflows: {
placement: Placement_2;
overflows: number[];
}[];
};
flip?: {
index?: number;
overflows: {
placement: Placement_2;
overflows: number[];
}[];
};
hide?: {
referenceHidden?: boolean;
escaped?: boolean;
referenceHiddenOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
escapedOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
};
offset?: {
x: number;
y: number;
};
shift?: {
x: number;
y: number;
};
};
}) => void>;
readonly reference: {
type: Vue3.PropType<ReferenceType>;
};
readonly floating: {
type: Vue3.PropType<HTMLElement>;
};
readonly strategy: Omit<{
type: new (...args: any[]) => Strategy_2 & {};
} | {
type: () => Strategy_2;
} | {
type: ((new (...args: any[]) => Strategy_2 & {}) | (() => Strategy_2))[];
}, "default"> & {
default: "absolute";
};
readonly middleware: Vue3.PropType<Middleware[]>;
readonly placement: Omit<{
type: new (...args: any[]) => Placement_2 & {};
} | {
type: () => Placement_2;
} | {
type: ((new (...args: any[]) => Placement_2 & {}) | (() => Placement_2))[];
}, "default"> & {
default: "bottom";
};
readonly autoUpdate: Omit<{
type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
} | {
type: () => boolean | UseAutoUpdateOptions;
} | {
type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
}, "default"> & {
default: true;
};
}, {
readonly appendTo: "body";
readonly shift: true;
readonly placement: "bottom";
readonly strategy: "absolute";
readonly autoUpdate: true;
}>>>, {
    readonly shift: boolean | ShiftOptions;
    readonly open: boolean;
    readonly disabled: boolean;
    readonly strategy: Strategy_2;
    readonly placement: Placement_2;
    readonly autoUpdate: true;
    readonly appendTo: string | false | HTMLElement;
    readonly autoUpdateOnClosed: boolean;
    readonly gpuAcceleration: boolean;
    readonly destoryedOnClosed: boolean;
}>;

export declare const PopupDefaultProps: {
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
};

export declare interface PopupExposed {
    updatePosition: () => void;
    getFloatingData: () => FloatingData | undefined;
    getElements: () => {
        floating: FloatingType | undefined;
        reference: ReferenceType | undefined;
    };
}

export declare const PopupProps: WithDefaultProps<    {
/**
* Whether to open popup.
*/
readonly open: BooleanConstructor;
/**
* Whether to disable the floating.
*/
readonly disabled: BooleanConstructor;
/**
* You can position a floating element relative to a virtual element instead of a real one.
* This enables things like positioning context menus or following the cursor.
* @see https://floating-ui.com/docs/virtual-elements
*/
readonly virtualElement: PropType<VirtualElement>;
/**
* When this value is `true`, popup will be teleport to the target.
* The teleport to target must be already in the DOM when the <Teleport> component is mounted.
* @see https://vuejs.org/guide/built-ins/teleport.html
*
* Or you can customize the teleport logic, set `appendTo` to false, and use `floatingWrapper`,
* for simple example
* ```tsx
* {
*   appendTo: false,
*   floatingWrapper: (floating) => h(
*    Teleport,
*    {
*      to: anyTarget
*    },
*    {
*      default: () => [floating]
*    }
*   )
* }
* ```
* @default 'body'
*/
readonly appendTo: PropType<string | false | HTMLElement>;
/**
* When this value is `false`, even if the popup is closed, floating will update the position as needed,
* unless popup is disabled.
*/
readonly autoUpdateOnClosed: BooleanConstructor;
/**
* Displaces the popup element from its core placement along the specified axes.
* @see https://floating-ui.com/docs/offset
*/
readonly offset: PropType<OffsetOptions>;
/**
* Moves the popup element along the specified axes in order to keep it in view.
* @default true
* @see https://floating-ui.com/docs/shift
*/
readonly shift: PropType<boolean | ShiftOptions>;
/**
* Changes the placement of the popup element to the opposite one by default in order to keep it in view.
* @see https://floating-ui.com/docs/flip
*/
readonly flip: PropType<boolean | FlipOptions>;
/**
* Chooses the placement that has the most space available automatically.
*
* You’ll want to use this instead of `flip` if you don't want to give the popup element a “preferred” placement
* and let it choose a placement for you.
* @see https://floating-ui.com/docs/autoPlacement
*/
readonly autoPlacement: PropType<boolean | AutoPlacementOptions>;
/**
* This determines whether GPU-accelerated styles are used to position the popup.
* When this value is `true`, popup will use the 3D transforms.
* When this value is `false`, popup will use top/left properties.
*/
readonly gpuAcceleration: BooleanConstructor;
/**
* Whether destroy popup when closed.
*/
readonly destoryedOnClosed: BooleanConstructor;
/**
* HTML attributes of node.
*/
readonly referenceProps: PropType<Record<string, any>>;
/**
* HTML attributes of node.
*/
readonly popupProps: PropType<Record<string, any>>;
/**
* Custom popup node wrapper.
* The basic DOM structure is `<Floating/> -> <Popup/> -> <PopupContent/>`.
*/
readonly popupWrapper: PropType<(popup: VNode | null) => VNode>;
/**
* Custom floating node wrapper.
* The basic DOM structure is `<Floating/> -> <Popup/> -> <PopupContent/>`.
*/
readonly floatingWrapper: PropType<(popup: VNode | null) => VNode>;
/**
* Popup z-index.
*/
readonly zIndex: NumberConstructor;
readonly onFloatingDataUpdate: PropType<(data: {
x: number;
y: number;
strategy: Strategy;
placement: Placement;
middlewareData: {
[x: string]: any;
arrow?: {
x?: number;
y?: number;
centerOffset: number;
};
autoPlacement?: {
index?: number;
overflows: {
placement: Placement;
overflows: number[];
}[];
};
flip?: {
index?: number;
overflows: {
placement: Placement;
overflows: number[];
}[];
};
hide?: {
referenceHidden?: boolean;
escaped?: boolean;
referenceHiddenOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
escapedOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
};
offset?: {
x: number;
y: number;
};
shift?: {
x: number;
y: number;
};
};
}) => void>;
readonly reference: {
type: PropType<ReferenceType>;
};
readonly floating: {
type: PropType<HTMLElement>;
};
readonly strategy: Omit<{
type: new (...args: any[]) => Strategy & {};
} | {
type: () => Strategy;
} | {
type: ((new (...args: any[]) => Strategy & {}) | (() => Strategy))[];
}, "default"> & {
default: "absolute";
};
readonly middleware: PropType<Middleware[]>;
readonly placement: Omit<{
type: new (...args: any[]) => Placement & {};
} | {
type: () => Placement;
} | {
type: ((new (...args: any[]) => Placement & {}) | (() => Placement))[];
}, "default"> & {
default: "bottom";
};
readonly autoUpdate: Omit<{
type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
} | {
type: () => boolean | UseAutoUpdateOptions;
} | {
type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
}, "default"> & {
default: true;
};
}, {
readonly appendTo: "body";
readonly shift: true;
readonly placement: "bottom";
readonly strategy: "absolute";
readonly autoUpdate: true;
}>;

export declare type PopupProps = ExtractPropTypes<typeof PopupProps>;

export declare const PopupPropsType: {
    /**
     * Whether to open popup.
     */
    readonly open: BooleanConstructor;
    /**
     * Whether to disable the floating.
     */
    readonly disabled: BooleanConstructor;
    /**
     * You can position a floating element relative to a virtual element instead of a real one.
     * This enables things like positioning context menus or following the cursor.
     * @see https://floating-ui.com/docs/virtual-elements
     */
    readonly virtualElement: PropType<VirtualElement>;
    /**
     * When this value is `true`, popup will be teleport to the target.
     * The teleport to target must be already in the DOM when the <Teleport> component is mounted.
     * @see https://vuejs.org/guide/built-ins/teleport.html
     *
     * Or you can customize the teleport logic, set `appendTo` to false, and use `floatingWrapper`,
     * for simple example
     * ```tsx
     * {
     *   appendTo: false,
     *   floatingWrapper: (floating) => h(
     *    Teleport,
     *    {
     *      to: anyTarget
     *    },
     *    {
     *      default: () => [floating]
     *    }
     *   )
     * }
     * ```
     * @default 'body'
     */
    readonly appendTo: PropType<string | false | HTMLElement>;
    /**
     * When this value is `false`, even if the popup is closed, floating will update the position as needed,
     * unless popup is disabled.
     */
    readonly autoUpdateOnClosed: BooleanConstructor;
    /**
     * Displaces the popup element from its core placement along the specified axes.
     * @see https://floating-ui.com/docs/offset
     */
    readonly offset: PropType<OffsetOptions>;
    /**
     * Moves the popup element along the specified axes in order to keep it in view.
     * @default true
     * @see https://floating-ui.com/docs/shift
     */
    readonly shift: PropType<boolean | ShiftOptions>;
    /**
     * Changes the placement of the popup element to the opposite one by default in order to keep it in view.
     * @see https://floating-ui.com/docs/flip
     */
    readonly flip: PropType<boolean | FlipOptions>;
    /**
     * Chooses the placement that has the most space available automatically.
     *
     * You’ll want to use this instead of `flip` if you don't want to give the popup element a “preferred” placement
     * and let it choose a placement for you.
     * @see https://floating-ui.com/docs/autoPlacement
     */
    readonly autoPlacement: PropType<boolean | AutoPlacementOptions>;
    /**
     * This determines whether GPU-accelerated styles are used to position the popup.
     * When this value is `true`, popup will use the 3D transforms.
     * When this value is `false`, popup will use top/left properties.
     */
    readonly gpuAcceleration: BooleanConstructor;
    /**
     * Whether destroy popup when closed.
     */
    readonly destoryedOnClosed: BooleanConstructor;
    /**
     * HTML attributes of node.
     */
    readonly referenceProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of node.
     */
    readonly popupProps: PropType<Record<string, any>>;
    /**
     * Custom popup node wrapper.
     * The basic DOM structure is `<Floating/> -> <Popup/> -> <PopupContent/>`.
     */
    readonly popupWrapper: PropType<(popup: VNode | null) => VNode>;
    /**
     * Custom floating node wrapper.
     * The basic DOM structure is `<Floating/> -> <Popup/> -> <PopupContent/>`.
     */
    readonly floatingWrapper: PropType<(popup: VNode | null) => VNode>;
    /**
     * Popup z-index.
     */
    readonly zIndex: NumberConstructor;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: Strategy;
        placement: Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly reference: {
        type: PropType<ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => Strategy & {};
    } | {
        type: () => Strategy;
    } | {
        type: ((new (...args: any[]) => Strategy & {}) | (() => Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: PropType<Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => Placement & {};
    } | {
        type: () => Placement;
    } | {
        type: ((new (...args: any[]) => Placement & {}) | (() => Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
};

export declare type PopupSlotProps = FloatingData;

export declare const providePopupContextValue: (contextValue: ForwardReferenceContextValue) => void;

declare type ReferenceType = Element | VirtualElement

export { Strategy }

export declare const Tooltip: DefineComponent<WithDefaultProps<    {
readonly content: PropType<string | (() => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>)>;
readonly textAlign: PropType<"center" | "end" | "start" | "left" | "right" | "justify" | "match-parent">;
readonly tooltipProps: PropType<Record<string, any>>;
readonly tooltipWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
readonly onFloatingDataUpdate: PropType<(data: {
x: number;
y: number;
strategy: Strategy;
placement: Placement;
middlewareData: {
[x: string]: any;
arrow?: {
x?: number;
y?: number;
centerOffset: number;
};
autoPlacement?: {
index?: number;
overflows: {
placement: Placement;
overflows: number[];
}[];
};
flip?: {
index?: number;
overflows: {
placement: Placement;
overflows: number[];
}[];
};
hide?: {
referenceHidden?: boolean;
escaped?: boolean;
referenceHiddenOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
escapedOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
};
offset?: {
x: number;
y: number;
};
shift?: {
x: number;
y: number;
};
};
}) => void>;
readonly 'onUpdate:open': PropType<(open: boolean, info: InteractionInfo) => void>;
readonly onOpen: PropType<(info: InteractionInfo) => void>;
readonly onClose: PropType<(info: InteractionInfo) => void>;
readonly shift: Omit<Omit<{
type: new (...args: any[]) => (boolean | ShiftOptions) & {};
} | {
type: () => boolean | ShiftOptions;
} | {
type: ((new (...args: any[]) => (boolean | ShiftOptions) & {}) | (() => boolean | ShiftOptions))[];
}, "default"> & {
default: true;
}, "default"> & {
default: true;
};
readonly offset: PropType<OffsetOptions>;
readonly open: BooleanConstructor;
readonly zIndex: NumberConstructor;
readonly title: PropType<string | (() => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>)>;
readonly disabled: BooleanConstructor;
readonly size: Omit<{
type: new (...args: any[]) => ("small" | "meduim") & {};
} | {
type: () => "small" | "meduim";
} | {
type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
}, "default"> & {
default: "meduim";
};
readonly reference: {
type: PropType<ReferenceType>;
};
readonly floating: {
type: PropType<HTMLElement>;
};
readonly strategy: Omit<Omit<Omit<{
type: new (...args: any[]) => Strategy & {};
} | {
type: () => Strategy;
} | {
type: ((new (...args: any[]) => Strategy & {}) | (() => Strategy))[];
}, "default"> & {
default: "absolute";
}, "default"> & {
default: "absolute";
}, "default"> & {
default: "absolute";
};
readonly arrow: PropType<CreateArrow>;
readonly autoPlacement: PropType<boolean | AutoPlacementOptions>;
readonly flip: PropType<boolean | FlipOptions>;
readonly middleware: PropType<Middleware[]>;
readonly placement: Omit<Omit<Omit<{
type: new (...args: any[]) => Placement & {};
} | {
type: () => Placement;
} | {
type: ((new (...args: any[]) => Placement & {}) | (() => Placement))[];
}, "default"> & {
default: "bottom";
}, "default"> & {
default: "bottom";
}, "default"> & {
default: "bottom";
};
readonly autoUpdate: Omit<Omit<Omit<{
type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
} | {
type: () => boolean | UseAutoUpdateOptions;
} | {
type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
}, "default"> & {
default: true;
}, "default"> & {
default: true;
}, "default"> & {
default: true;
};
readonly virtualElement: PropType<VirtualElement>;
readonly appendTo: Omit<Omit<{
type: new (...args: any[]) => (string | false | HTMLElement) & {};
} | {
type: () => string | false | HTMLElement;
} | {
type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
}, "default"> & {
default: "body";
}, "default"> & {
default: "body";
};
readonly autoUpdateOnClosed: BooleanConstructor;
readonly gpuAcceleration: BooleanConstructor;
readonly destoryedOnClosed: BooleanConstructor;
readonly referenceProps: PropType<Record<string, any>>;
readonly popupProps: PropType<Record<string, any>>;
readonly popupWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
readonly floatingWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
readonly defaultOpen: BooleanConstructor;
readonly interactions: Omit<{
type: new (...args: any[]) => Interaction[];
} | {
type: () => Interaction[];
} | {
type: ((new (...args: any[]) => Interaction[]) | (() => Interaction[]))[];
}, "default"> & {
default: () => string[];
};
readonly delay: PropType<number>;
readonly clickDelay: PropType<number>;
readonly hoverDelay: PropType<number>;
readonly focusDelay: PropType<number>;
readonly keepOpenWhenPopupHover: Omit<{
type: BooleanConstructor;
}, "default"> & {
default: true;
};
readonly closeWhenClickOutside: Omit<{
type: BooleanConstructor;
}, "default"> & {
default: true;
};
readonly theme: Omit<{
type: new (...args: any[]) => ("dark" | "light") & {};
} | {
type: () => "dark" | "light";
} | {
type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
}, "default"> & {
default: "line";
};
readonly transitionProps: Omit<{
type: new (...args: any[]) => (string | Record<string, any>) & {};
} | {
type: () => string | Record<string, any>;
} | {
type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
}, "default"> & {
default: "visoning-popover";
};
readonly showArrow: Omit<{
type: BooleanConstructor;
}, "default"> & {
default: true;
};
readonly arrowProps: PropType<Record<string, any>>;
readonly popoverProps: PropType<Record<string, any>>;
readonly contentProps: PropType<Record<string, any>>;
readonly popoverWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
}, {
readonly textAlign: "start";
readonly open: any;
readonly interactions: () => string[];
readonly keepOpenWhenPopupHover: true;
readonly closeWhenClickOutside: true;
readonly theme: "line";
readonly size: "meduim";
readonly transitionProps: "visoning-popover";
readonly showArrow: true;
readonly appendTo: "body";
readonly shift: true;
readonly placement: "bottom";
readonly strategy: "absolute";
readonly autoUpdate: true;
}>, () => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<WithDefaultProps<    {
readonly content: PropType<string | (() => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>)>;
readonly textAlign: PropType<"center" | "end" | "start" | "left" | "right" | "justify" | "match-parent">;
readonly tooltipProps: PropType<Record<string, any>>;
readonly tooltipWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
readonly onFloatingDataUpdate: PropType<(data: {
x: number;
y: number;
strategy: Strategy;
placement: Placement;
middlewareData: {
[x: string]: any;
arrow?: {
x?: number;
y?: number;
centerOffset: number;
};
autoPlacement?: {
index?: number;
overflows: {
placement: Placement;
overflows: number[];
}[];
};
flip?: {
index?: number;
overflows: {
placement: Placement;
overflows: number[];
}[];
};
hide?: {
referenceHidden?: boolean;
escaped?: boolean;
referenceHiddenOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
escapedOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
};
offset?: {
x: number;
y: number;
};
shift?: {
x: number;
y: number;
};
};
}) => void>;
readonly 'onUpdate:open': PropType<(open: boolean, info: InteractionInfo) => void>;
readonly onOpen: PropType<(info: InteractionInfo) => void>;
readonly onClose: PropType<(info: InteractionInfo) => void>;
readonly shift: Omit<Omit<{
type: new (...args: any[]) => (boolean | ShiftOptions) & {};
} | {
type: () => boolean | ShiftOptions;
} | {
type: ((new (...args: any[]) => (boolean | ShiftOptions) & {}) | (() => boolean | ShiftOptions))[];
}, "default"> & {
default: true;
}, "default"> & {
default: true;
};
readonly offset: PropType<OffsetOptions>;
readonly open: BooleanConstructor;
readonly zIndex: NumberConstructor;
readonly title: PropType<string | (() => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>)>;
readonly disabled: BooleanConstructor;
readonly size: Omit<{
type: new (...args: any[]) => ("small" | "meduim") & {};
} | {
type: () => "small" | "meduim";
} | {
type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
}, "default"> & {
default: "meduim";
};
readonly reference: {
type: PropType<ReferenceType>;
};
readonly floating: {
type: PropType<HTMLElement>;
};
readonly strategy: Omit<Omit<Omit<{
type: new (...args: any[]) => Strategy & {};
} | {
type: () => Strategy;
} | {
type: ((new (...args: any[]) => Strategy & {}) | (() => Strategy))[];
}, "default"> & {
default: "absolute";
}, "default"> & {
default: "absolute";
}, "default"> & {
default: "absolute";
};
readonly arrow: PropType<CreateArrow>;
readonly autoPlacement: PropType<boolean | AutoPlacementOptions>;
readonly flip: PropType<boolean | FlipOptions>;
readonly middleware: PropType<Middleware[]>;
readonly placement: Omit<Omit<Omit<{
type: new (...args: any[]) => Placement & {};
} | {
type: () => Placement;
} | {
type: ((new (...args: any[]) => Placement & {}) | (() => Placement))[];
}, "default"> & {
default: "bottom";
}, "default"> & {
default: "bottom";
}, "default"> & {
default: "bottom";
};
readonly autoUpdate: Omit<Omit<Omit<{
type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
} | {
type: () => boolean | UseAutoUpdateOptions;
} | {
type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
}, "default"> & {
default: true;
}, "default"> & {
default: true;
}, "default"> & {
default: true;
};
readonly virtualElement: PropType<VirtualElement>;
readonly appendTo: Omit<Omit<{
type: new (...args: any[]) => (string | false | HTMLElement) & {};
} | {
type: () => string | false | HTMLElement;
} | {
type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
}, "default"> & {
default: "body";
}, "default"> & {
default: "body";
};
readonly autoUpdateOnClosed: BooleanConstructor;
readonly gpuAcceleration: BooleanConstructor;
readonly destoryedOnClosed: BooleanConstructor;
readonly referenceProps: PropType<Record<string, any>>;
readonly popupProps: PropType<Record<string, any>>;
readonly popupWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
readonly floatingWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
readonly defaultOpen: BooleanConstructor;
readonly interactions: Omit<{
type: new (...args: any[]) => Interaction[];
} | {
type: () => Interaction[];
} | {
type: ((new (...args: any[]) => Interaction[]) | (() => Interaction[]))[];
}, "default"> & {
default: () => string[];
};
readonly delay: PropType<number>;
readonly clickDelay: PropType<number>;
readonly hoverDelay: PropType<number>;
readonly focusDelay: PropType<number>;
readonly keepOpenWhenPopupHover: Omit<{
type: BooleanConstructor;
}, "default"> & {
default: true;
};
readonly closeWhenClickOutside: Omit<{
type: BooleanConstructor;
}, "default"> & {
default: true;
};
readonly theme: Omit<{
type: new (...args: any[]) => ("dark" | "light") & {};
} | {
type: () => "dark" | "light";
} | {
type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
}, "default"> & {
default: "line";
};
readonly transitionProps: Omit<{
type: new (...args: any[]) => (string | Record<string, any>) & {};
} | {
type: () => string | Record<string, any>;
} | {
type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
}, "default"> & {
default: "visoning-popover";
};
readonly showArrow: Omit<{
type: BooleanConstructor;
}, "default"> & {
default: true;
};
readonly arrowProps: PropType<Record<string, any>>;
readonly popoverProps: PropType<Record<string, any>>;
readonly contentProps: PropType<Record<string, any>>;
readonly popoverWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
}, {
readonly textAlign: "start";
readonly open: any;
readonly interactions: () => string[];
readonly keepOpenWhenPopupHover: true;
readonly closeWhenClickOutside: true;
readonly theme: "line";
readonly size: "meduim";
readonly transitionProps: "visoning-popover";
readonly showArrow: true;
readonly appendTo: "body";
readonly shift: true;
readonly placement: "bottom";
readonly strategy: "absolute";
readonly autoUpdate: true;
}>>>, {
readonly shift: boolean | ShiftOptions;
readonly open: boolean;
readonly textAlign: "center" | "end" | "start" | "left" | "right" | "justify" | "match-parent";
readonly disabled: boolean;
readonly size: "small" | "meduim";
readonly strategy: Strategy;
readonly placement: Placement;
readonly autoUpdate: true;
readonly appendTo: string | false | HTMLElement;
readonly autoUpdateOnClosed: boolean;
readonly gpuAcceleration: boolean;
readonly destoryedOnClosed: boolean;
readonly defaultOpen: boolean;
readonly interactions: Interaction[];
readonly keepOpenWhenPopupHover: boolean;
readonly closeWhenClickOutside: boolean;
readonly theme: "dark" | "light";
readonly transitionProps: "visoning-popover";
readonly showArrow: boolean;
}>;

export declare type TooltipArrowSlotProps = PopoverArrowSlotProps;

export declare const TooltipDefaultProps: {
    readonly textAlign: "start";
    readonly open: any;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
};

export declare interface TooltipExposed extends PopoverExposed {
}

export declare const TooltipProps: WithDefaultProps<    {
/**
* support: string | VNode | slot
*/
readonly content: PropType<string | (() => VNode)>;
/**
* align tooltip content. enum of CSS text-align.
* @default 'start'
*/
readonly textAlign: PropType<"center" | "end" | "start" | "left" | "right" | "justify" | "match-parent">;
/**
* HTML attributes of node.
*/
readonly tooltipProps: PropType<Record<string, any>>;
/**
* Custom tooltip node wrapper.
*/
readonly tooltipWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
readonly onFloatingDataUpdate: PropType<(data: {
x: number;
y: number;
strategy: Strategy;
placement: Placement;
middlewareData: {
[x: string]: any;
arrow?: {
x?: number;
y?: number;
centerOffset: number;
};
autoPlacement?: {
index?: number;
overflows: {
placement: Placement;
overflows: number[];
}[];
};
flip?: {
index?: number;
overflows: {
placement: Placement;
overflows: number[];
}[];
};
hide?: {
referenceHidden?: boolean;
escaped?: boolean;
referenceHiddenOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
escapedOffsets?: {
left: number;
top: number;
bottom: number;
right: number;
};
};
offset?: {
x: number;
y: number;
};
shift?: {
x: number;
y: number;
};
};
}) => void>;
readonly 'onUpdate:open': PropType<(open: boolean, info: InteractionInfo) => void>;
readonly onOpen: PropType<(info: InteractionInfo) => void>;
readonly onClose: PropType<(info: InteractionInfo) => void>;
readonly shift: Omit<Omit<{
type: new (...args: any[]) => (boolean | ShiftOptions) & {};
} | {
type: () => boolean | ShiftOptions;
} | {
type: ((new (...args: any[]) => (boolean | ShiftOptions) & {}) | (() => boolean | ShiftOptions))[];
}, "default"> & {
default: true;
}, "default"> & {
default: true;
};
readonly offset: PropType<OffsetOptions>;
readonly open: BooleanConstructor;
readonly zIndex: NumberConstructor;
readonly title: PropType<string | (() => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>)>;
readonly disabled: BooleanConstructor;
readonly size: Omit<{
type: new (...args: any[]) => ("small" | "meduim") & {};
} | {
type: () => "small" | "meduim";
} | {
type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
}, "default"> & {
default: "meduim";
};
readonly reference: {
type: PropType<ReferenceType>;
};
readonly floating: {
type: PropType<HTMLElement>;
};
readonly strategy: Omit<Omit<Omit<{
type: new (...args: any[]) => Strategy & {};
} | {
type: () => Strategy;
} | {
type: ((new (...args: any[]) => Strategy & {}) | (() => Strategy))[];
}, "default"> & {
default: "absolute";
}, "default"> & {
default: "absolute";
}, "default"> & {
default: "absolute";
};
readonly arrow: PropType<CreateArrow>;
readonly autoPlacement: PropType<boolean | AutoPlacementOptions>;
readonly flip: PropType<boolean | FlipOptions>;
readonly middleware: PropType<Middleware[]>;
readonly placement: Omit<Omit<Omit<{
type: new (...args: any[]) => Placement & {};
} | {
type: () => Placement;
} | {
type: ((new (...args: any[]) => Placement & {}) | (() => Placement))[];
}, "default"> & {
default: "bottom";
}, "default"> & {
default: "bottom";
}, "default"> & {
default: "bottom";
};
readonly autoUpdate: Omit<Omit<Omit<{
type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
} | {
type: () => boolean | UseAutoUpdateOptions;
} | {
type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
}, "default"> & {
default: true;
}, "default"> & {
default: true;
}, "default"> & {
default: true;
};
readonly virtualElement: PropType<VirtualElement>;
readonly appendTo: Omit<Omit<{
type: new (...args: any[]) => (string | false | HTMLElement) & {};
} | {
type: () => string | false | HTMLElement;
} | {
type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
}, "default"> & {
default: "body";
}, "default"> & {
default: "body";
};
readonly autoUpdateOnClosed: BooleanConstructor;
readonly gpuAcceleration: BooleanConstructor;
readonly destoryedOnClosed: BooleanConstructor;
readonly referenceProps: PropType<Record<string, any>>;
readonly popupProps: PropType<Record<string, any>>;
readonly popupWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
readonly floatingWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
readonly defaultOpen: BooleanConstructor;
readonly interactions: Omit<{
type: new (...args: any[]) => Interaction[];
} | {
type: () => Interaction[];
} | {
type: ((new (...args: any[]) => Interaction[]) | (() => Interaction[]))[];
}, "default"> & {
default: () => string[];
};
readonly delay: PropType<number>;
readonly clickDelay: PropType<number>;
readonly hoverDelay: PropType<number>;
readonly focusDelay: PropType<number>;
readonly keepOpenWhenPopupHover: Omit<{
type: BooleanConstructor;
}, "default"> & {
default: true;
};
readonly closeWhenClickOutside: Omit<{
type: BooleanConstructor;
}, "default"> & {
default: true;
};
readonly theme: Omit<{
type: new (...args: any[]) => ("dark" | "light") & {};
} | {
type: () => "dark" | "light";
} | {
type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
}, "default"> & {
default: "line";
};
readonly transitionProps: Omit<{
type: new (...args: any[]) => (string | Record<string, any>) & {};
} | {
type: () => string | Record<string, any>;
} | {
type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
}, "default"> & {
default: "visoning-popover";
};
readonly showArrow: Omit<{
type: BooleanConstructor;
}, "default"> & {
default: true;
};
readonly arrowProps: PropType<Record<string, any>>;
readonly popoverProps: PropType<Record<string, any>>;
readonly contentProps: PropType<Record<string, any>>;
readonly popoverWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
[key: string]: any;
}>) => VNode<RendererNode, RendererElement, {
[key: string]: any;
}>>;
}, {
readonly textAlign: "start";
readonly open: any;
readonly interactions: () => string[];
readonly keepOpenWhenPopupHover: true;
readonly closeWhenClickOutside: true;
readonly theme: "line";
readonly size: "meduim";
readonly transitionProps: "visoning-popover";
readonly showArrow: true;
readonly appendTo: "body";
readonly shift: true;
readonly placement: "bottom";
readonly strategy: "absolute";
readonly autoUpdate: true;
}>;

export declare type TooltipProps = ExtractPropTypes<typeof TooltipProps>;

export declare const TooltipPropsType: {
    /**
     * support: string | VNode | slot
     */
    readonly content: PropType<string | (() => VNode)>;
    /**
     * align tooltip content. enum of CSS text-align.
     * @default 'start'
     */
    readonly textAlign: PropType<"center" | "end" | "start" | "left" | "right" | "justify" | "match-parent">;
    /**
     * HTML attributes of node.
     */
    readonly tooltipProps: PropType<Record<string, any>>;
    /**
     * Custom tooltip node wrapper.
     */
    readonly tooltipWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>) => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: Strategy;
        placement: Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly 'onUpdate:open': PropType<(open: boolean, info: InteractionInfo) => void>;
    readonly onOpen: PropType<(info: InteractionInfo) => void>;
    readonly onClose: PropType<(info: InteractionInfo) => void>;
    readonly shift: Omit<Omit<{
        type: new (...args: any[]) => (boolean | ShiftOptions) & {};
    } | {
        type: () => boolean | ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | ShiftOptions) & {}) | (() => boolean | ShiftOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<OffsetOptions>;
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly title: PropType<string | (() => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>)>;
    readonly disabled: BooleanConstructor;
    readonly size: Omit<{
        type: new (...args: any[]) => ("small" | "meduim") & {};
    } | {
        type: () => "small" | "meduim";
    } | {
        type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
    }, "default"> & {
        default: "meduim";
    };
    readonly reference: {
        type: PropType<ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<Omit<Omit<{
        type: new (...args: any[]) => Strategy & {};
    } | {
        type: () => Strategy;
    } | {
        type: ((new (...args: any[]) => Strategy & {}) | (() => Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly arrow: PropType<CreateArrow>;
    readonly autoPlacement: PropType<boolean | AutoPlacementOptions>;
    readonly flip: PropType<boolean | FlipOptions>;
    readonly middleware: PropType<Middleware[]>;
    readonly placement: Omit<Omit<Omit<{
        type: new (...args: any[]) => Placement & {};
    } | {
        type: () => Placement;
    } | {
        type: ((new (...args: any[]) => Placement & {}) | (() => Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<Omit<Omit<{
        type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: PropType<VirtualElement>;
    readonly appendTo: Omit<Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>) => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>) => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>>;
    readonly defaultOpen: BooleanConstructor;
    readonly interactions: Omit<{
        type: new (...args: any[]) => Interaction[];
    } | {
        type: () => Interaction[];
    } | {
        type: ((new (...args: any[]) => Interaction[]) | (() => Interaction[]))[];
    }, "default"> & {
        default: () => string[];
    };
    readonly delay: PropType<number>;
    readonly clickDelay: PropType<number>;
    readonly hoverDelay: PropType<number>;
    readonly focusDelay: PropType<number>;
    readonly keepOpenWhenPopupHover: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly closeWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly theme: Omit<{
        type: new (...args: any[]) => ("dark" | "light") & {};
    } | {
        type: () => "dark" | "light";
    } | {
        type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
    }, "default"> & {
        default: "line";
    };
    readonly transitionProps: Omit<{
        type: new (...args: any[]) => (string | Record<string, any>) & {};
    } | {
        type: () => string | Record<string, any>;
    } | {
        type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
    }, "default"> & {
        default: "visoning-popover";
    };
    readonly showArrow: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly arrowProps: PropType<Record<string, any>>;
    readonly popoverProps: PropType<Record<string, any>>;
    readonly contentProps: PropType<Record<string, any>>;
    readonly popoverWrapper: PropType<(popup: VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>) => VNode<RendererNode, RendererElement, {
        [key: string]: any;
    }>>;
};

declare type UseAutoUpdateOptions = Partial<AutoUpdateOptions_2> & {
    /**
     * @default false
     */
    disabled?: boolean
}

declare interface UseFloatingData {
    x: number | null
    y: number | null
    strategy: Strategy
    placement: Placement
    middlewareData: MiddlewareData
}

export declare const useReferenceForwardContext: () => ForwardReferenceContextValue;

export declare const useSafeReferenceForwardContent: () => ForwardReferenceContextValue;

export { VirtualElement }

export { }
